Unit AMM5R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMM5R(var A :Array of Real; var B :Array of Real;
                N :Integer; var C :Array of Real); 
implementation

procedure AMM5R(var A :Array of Real; var B :Array of Real;
                N :Integer; var C :Array of Real);
var
LI,IR,LJ,JC,I,J,K :Integer;
TEMP :Real;
label
_5,_10,_15,_20,_25,_30;
begin
LI := 1;
for IR:=1 to N do
 begin
  LJ := 1;
  for JC:=1 to N do
   begin
    I := LI;
    J := LJ;
    TEMP := 0.0;
    for K:=1 to N do
     begin
      TEMP := A[I-1] * B[J-1] + TEMP;
      if ( K < IR ) 
       then goto _5;
      I := I + K;
      goto _10;
_5:
      I := I + 1;
_10:
      if ( K < JC ) 
       then goto _15;
      J := J + K;
      goto _20;
_15:
      J := J + 1;
_20:
     end;
    C[(IR-1)+(JC-1)*N] := TEMP;
    LJ := LJ + JC;
_25:
   end;
  LI := LI + IR;
_30:
 end;
end;

end.
